/**
 *
 */
package com.adc.da.mp;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.core.exceptions.MybatisPlusException;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.InjectionConfig;
import com.baomidou.mybatisplus.generator.config.*;
import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class CodeGenerator {

    private static String moduleName = "test";    //模块名称
    private static String author = "gen";    //作者
    //    private static String projectPath = "D:\\IdeaProjects\\git\\PSSP\\PSSP-Server\\PSSP-RDBMS";    //代码生成路径
//    private static String projectPath = "D:\\Workspace\\ADCBS\\adcbs-vdaims";    //代码生成路径
    private static String projectPath = "";
    private static String[] tablePrefix = new String[]{"TR_", "TS_", "V_", "T_"};    //表前缀
    //     private static String url = "jdbc:oracle:thin:@123.127.164.5:28628:rep";    //数据源url
//     private static String username = "NERDS";    //数据源连接用户名
//     private static String password = "kahmezVWtFDC9IDn";    //数据源连接密码
    private static String url = "jdbc:oracle:thin:@60.247.58.117:50010:ADC";    //数据源url
    private static String username = "nerds";    //数据源连接用户名
    private static String password = "nerds";    //数据源连接密码

//    private static String url = "jdbc:oracle:thin:@60.247.58.117:50010:ADC";    //数据源url
//    private static String username = "retrieval";    //数据源连接用户名
//    private static String password = "retrieval";    //数据源连接密码

    public static void main(String[] args) {

        String[] tableNames = new String[]{"CERT_PRINTER"};    //需要生成代码的数据库表名


        gen(tableNames);
    }

    private static void gen(String[] tableNames) {
        // 代码生成器
        AutoGenerator mpg = new AutoGenerator();

        // 全局配置
        GlobalConfig gc = new GlobalConfig();
        gc.setOutputDir(projectPath + "/src/main/java");
        gc.setAuthor(author);
        gc.setOpen(false);
        gc.setSwagger2(true); //实体属性 Swagger2 注解
        gc.setBaseColumnList(true);
        gc.setBaseResultMap(true);
        gc.setIdType(IdType.UUID);
        gc.setDateType(DateType.ONLY_DATE);
        gc.setFileOverride(true);
        gc.setActiveRecord(true);
        gc.setControllerName("%sEOController");
        gc.setServiceName("I%sEOService");
        gc.setServiceImplName("%sEOServiceImpl");
        gc.setEntityName("%s");
        gc.setMapperName("%sEODao");
        gc.setXmlName("%sEOMapper");
//        gc.setEnableCache(true);
        mpg.setGlobalConfig(gc);

        // 数据源配置
        DataSourceConfig dsc = new DataSourceConfig();
        dsc.setUrl(url);
        // dsc.setSchemaName("public");
        dsc.setDriverName("oracle.jdbc.OracleDriver");
//        dsc.setDriverName("com.mysql.cj.jdbc.Driver");
        dsc.setUsername(username);
        dsc.setPassword(password);
        mpg.setDataSource(dsc);

        // 包配置
        PackageConfig pc = new PackageConfig();
        pc.setModuleName(moduleName);
        pc.setParent("com.adc.da");
        pc.setMapper("dao");
        mpg.setPackageInfo(pc);

        // 自定义配置
        InjectionConfig cfg = new InjectionConfig() {
            @Override
            public void initMap() {
//                Map<String, Object> map = new HashMap<>();
//                map.put("restPath", "${restPath}");
//                this.setMap(map);
            }
        };

        // 如果模板引擎是 freemarker
        String templatePath = "/templates/mapper.xml.ftl";
        String templatePath2 = "/templates/entity.java.ftl";
        // 如果模板引擎是 velocity
        // String templatePath = "/templates/mapper.xml.vm";

        // 自定义输出配置
        List<FileOutConfig> focList = new ArrayList<>();
        // 自定义配置会被优先输出
        focList.add(new FileOutConfig(templatePath) {
            @Override
            public String outputFile(TableInfo tableInfo) {
                // 自定义输出文件名 ， 如果你 Entity 设置了前后缀、此处注意 xml 的名称会跟着发生变化！！
                return projectPath + "/src/main/resources/mybatis/mapper/" + moduleName + "/" + tableInfo.getEntityName() + "EOMapper" +
                        StringPool.DOT_XML;
            }
        });
        focList.add(new FileOutConfig(templatePath2) {
            @Override
            public String outputFile(TableInfo tableInfo) {
                // 自定义输出文件名 ， 如果你 Entity 设置了前后缀、此处注意 xml 的名称会跟着发生变化！！
                return projectPath + "/src/main/java/com/adc/da/" + moduleName + "/entity/" + tableInfo.getEntityName() + "EO" +
                        StringPool.DOT_JAVA;
            }
        });
        /*
        cfg.setFileCreate(new IFileCreate() {
            @Override
            public boolean isCreate(ConfigBuilder configBuilder, FileType fileType, String filePath) {
                // 判断自定义文件夹是否需要创建
                checkDir("调用默认方法创建的目录");
                return false;
            }
        });
        */
        cfg.setFileOutConfigList(focList);
        mpg.setCfg(cfg);

        // 配置模板
        TemplateConfig templateConfig = new TemplateConfig();

        // 配置自定义输出模板
        //指定自定义模板路径，注意不要带上.ftl/.vm, 会根据使用的模板引擎自动识别
        // templateConfig.setEntity("templates/entity2.java");
        // templateConfig.setService();
        // templateConfig.setController();

        templateConfig.setEntity(null);
//        templateConfig.setService(null);
//        templateConfig.setServiceImpl(null);
        //注释掉之后会生成controller
//        templateConfig.setController(null);
//        templateConfig.setMapper(null);
        templateConfig.setXml(null);
        mpg.setTemplate(templateConfig);

        // 策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setControllerMappingHyphenStyle(false);
        strategy.setEntityTableFieldAnnotationEnable(true);
        strategy.setEntityColumnConstant(true);
        strategy.setNaming(NamingStrategy.underline_to_camel);
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);
        strategy.setEntityLombokModel(true);
        strategy.setEntitySerialVersionUID(true);
        //        strategy.setInclude("TR_PROPERTY_ENGINE", "TR_PROPERTY_VEHICLE", "TR_PROPERTY_VEHICLE_MODEL", "TR_ROLE_MENU",
        //                            "TR_USER_ROLE", "TS_DEPARTMENT", "TS_FILE", "TS_LOG", "TS_MENU", "TS_PROPERTY", "TS_ROLE",
        //                            "TS_TENANT", "TS_USER", "TS_AREA", "TT_CHIP", "TT_ENGINE", "TT_SIM", "TT_TERMINAL",
        //                            "TT_VEHICLE", "TT_VEHICLE_MODEL", "V_TENANT_PAGE", "V_USER_PAGE", "V_DEPARTMENT_PAGE",
        //                            "V_ROLE_PAGE");
        //                strategy.setInclude("TR_ROLE_MENU", "TR_USER_ROLE", "TS_DEPARTMENT", "TS_FILE", "TS_LOG", "TS_MENU",
        //                                    "TS_PROPERTY", "TS_ROLE", "TS_TENANT", "TS_USER");
        //                        strategy.setInclude("TR_PROPERTY_ENGINE", "TR_PROPERTY_VEHICLE", "TR_PROPERTY_VEHICLE_MODEL", "TT_CHIP",
        //                                            "TT_ENGINE", "TT_SIM", "TT_TERMINAL", "TT_VEHICLE", "TT_VEHICLE_MODEL");
//        strategy.setInclude("V_TERMINAL_PAGE","TT_CHIP","TT_TERMINAL");
        //        strategy.setInclude("TS_DEPARTMENT");
        //        strategy.setInclude("TS_USER", "TS_TENANT");
        //        strategy.setInclude("V_TENANT_PAGE", "TS_TENANT");
        //        strategy.setRestControllerStyle(true);
        strategy.setInclude(tableNames);
        // 公共父类
        strategy.setSuperControllerClass("com.adc.da.mp.base.BaseController");
        // 写于父类中的公共字段
        strategy.setSuperServiceClass("com.adc.da.mp.base.IBaseService");
        strategy.setSuperEntityClass("com.adc.da.mp.base.BaseEntity");
        //strategy.setSuperEntityClass("com.adc.da.rdbms.base.PsspBaseEntity");
        //strategy.setSuperEntityColumns("CREATE_USER_ID", "CREATE_USER_NAME", "CREATE_TIME", "UPDATE_USER_ID", "UPDATE_USER_NAME", "UPDATE_TIME");

        strategy.setRestControllerStyle(true);
        //        strategy.setSuperEntityColumns("id");
        //        strategy.setControllerMappingHyphenStyle(true);
        strategy.setTablePrefix(tablePrefix);
        mpg.setStrategy(strategy);
        mpg.setTemplateEngine(new FreemarkerTemplateEngine());
        mpg.execute();
    }

    /**
     * <p>
     * 读取控制台内容
     * </p>
     */
    public static String scanner(String tip) {

        Scanner scanner = new Scanner(System.in);
        StringBuilder help = new StringBuilder();
        help.append("请输入" + tip + "：");
        System.out.println(help.toString());
        if (scanner.hasNext()) {
            String ipt = scanner.next();
            if (StringUtils.isNotEmpty(ipt)) {
                return ipt;
            }
        }
        throw new MybatisPlusException("请输入正确的" + tip + "！");
    }

}

